diff --git a/doc/guide/https.xml b/doc/guide/https.xml
index 8f6becf2382b..894624c1285b 100644
--- a/doc/guide/https.xml
+++ b/doc/guide/https.xml
@@ -53,6 +53,10 @@ MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQCyOJ5garOYw0sm
 -----END PRIVATE KEY-----
 </programlisting>
 
+    <para>Note that for EC keys, the <literal>BEGIN EC PARAMETERS</literal> block must occur
+      <emphasis>before</emphasis> the <literal>BEGIN EC PRIVATE KEY</literal> block (this
+      is how OpenSSL, LetsEncrypt, etc. generate the key files).</para>
+
     <para>If no certificate is found, a self-signed certificate is created and
       stored in the <filename>0-self-signed.cert</filename> file. On some
       platforms, Cockpit will also generate a ca.crt in that directory, which
diff --git a/src/ws/Makefile-ws.am b/src/ws/Makefile-ws.am
index fd9982c089bb..a35bd20ca2ba 100644
--- a/src/ws/Makefile-ws.am
+++ b/src/ws/Makefile-ws.am
@@ -100,6 +100,8 @@ libcockpit_ws_LIBS = \
 
 EXTRA_DIST += \
 	src/ws/mock_cert \
+	src/ws/mock-ecc.crt \
+	src/ws/mock-ecc.key \
 	src/ws/mock-cat-with-init \
 	src/ws/mock-kdc \
 	src/ws/mock-krb5.conf.in \
diff --git a/src/ws/cockpitcertificate.c b/src/ws/cockpitcertificate.c
index 5d24523db5e1..9c33fad0e103 100644
--- a/src/ws/cockpitcertificate.c
+++ b/src/ws/cockpitcertificate.c
@@ -453,6 +453,9 @@ cockpit_certificate_locate (gboolean create_if_necessary,
 #define PEM_CERTIFICATE_FOOTER     "-----END CERTIFICATE-----"
 #define PEM_PKCS1_PRIVKEY_HEADER   "-----BEGIN RSA PRIVATE KEY-----"
 #define PEM_PKCS1_PRIVKEY_FOOTER   "-----END RSA PRIVATE KEY-----"
+/* this is slightly asymmetrical -- paraemters and private key occur in the same file */
+#define PEM_PKCS1_ECCKEY_HEADER   "-----BEGIN EC PARAMETERS-----"
+#define PEM_PKCS1_ECCKEY_FOOTER   "-----END EC PRIVATE KEY-----"
 #define PEM_PKCS8_PRIVKEY_HEADER   "-----BEGIN PRIVATE KEY-----"
 #define PEM_PKCS8_PRIVKEY_FOOTER   "-----END PRIVATE KEY-----"
 #define PEM_PKCS8_ENCRYPTED_HEADER "-----BEGIN ENCRYPTED PRIVATE KEY-----"
@@ -471,23 +474,29 @@ parse_private_key (const gchar *data,
     footer = PEM_PKCS1_PRIVKEY_FOOTER;
   else
     {
-      start = g_strstr_len (data, data_len, PEM_PKCS8_PRIVKEY_HEADER);
+      start = g_strstr_len (data, data_len, PEM_PKCS1_ECCKEY_HEADER);
       if (start)
-        footer = PEM_PKCS8_PRIVKEY_FOOTER;
+        footer = PEM_PKCS1_ECCKEY_FOOTER;
       else
         {
-          start = g_strstr_len (data, data_len, PEM_PKCS8_ENCRYPTED_HEADER);
+          start = g_strstr_len (data, data_len, PEM_PKCS8_PRIVKEY_HEADER);
           if (start)
+            footer = PEM_PKCS8_PRIVKEY_FOOTER;
+          else
             {
-              g_set_error_literal (error, G_TLS_ERROR, G_TLS_ERROR_BAD_CERTIFICATE,
-                                   _("Cannot decrypt PEM-encoded private key"));
+              start = g_strstr_len (data, data_len, PEM_PKCS8_ENCRYPTED_HEADER);
+              if (start)
+                {
+                  g_set_error_literal (error, G_TLS_ERROR, G_TLS_ERROR_BAD_CERTIFICATE,
+                                       _("Cannot decrypt PEM-encoded private key"));
+                }
+              else if (required)
+                {
+                  g_set_error_literal (error, G_TLS_ERROR, G_TLS_ERROR_BAD_CERTIFICATE,
+                                       _("No PEM-encoded private key found"));
+                }
+              return NULL;
             }
-          else if (required)
-            {
-              g_set_error_literal (error, G_TLS_ERROR, G_TLS_ERROR_BAD_CERTIFICATE,
-                                   _("No PEM-encoded private key found"));
-            }
-          return NULL;
         }
     }
 
diff --git a/src/ws/mock-ecc.crt b/src/ws/mock-ecc.crt
new file mode 100644
index 000000000000..15063b387edb
--- /dev/null
+++ b/src/ws/mock-ecc.crt
@@ -0,0 +1,13 @@
+# openssl req -new -key mock-ecc.key -x509 -nodes -days 3650 -subj '/CN=localhost' -out mock-ecc.crt
+
+-----BEGIN CERTIFICATE-----
+MIIBfTCCASOgAwIBAgIUZGnBgTO/jO+3Yns9Qa3CDVBVTMwwCgYIKoZIzj0EAwIw
+FDESMBAGA1UEAwwJbG9jYWxob3N0MB4XDTE5MTAzMTA5MTQzOFoXDTI5MTAyODA5
+MTQzOFowFDESMBAGA1UEAwwJbG9jYWxob3N0MFkwEwYHKoZIzj0CAQYIKoZIzj0D
+AQcDQgAE5BRvKPl0iCppAFY4luyrbS6wIRAV6CY3PkhNpWgcRk40q7Ev85LM7I2G
+wyMihC+GlrZkJ5cz0gzUrGawAsx/I6NTMFEwHQYDVR0OBBYEFPxh7cO94TEhFL0K
+ErzKK1kMC4VIMB8GA1UdIwQYMBaAFPxh7cO94TEhFL0KErzKK1kMC4VIMA8GA1Ud
+EwEB/wQFMAMBAf8wCgYIKoZIzj0EAwIDSAAwRQIgJjlmWh7neWQlLlJC/Gq+F3u+
+7Gnxltgi4V1/PHdgRNcCIQCQ03ftc6PHZfdVMILhNRKgZauPV06Nu6Bz20OSVTWR
+ig==
+-----END CERTIFICATE-----
diff --git a/src/ws/mock-ecc.key b/src/ws/mock-ecc.key
new file mode 100644
index 000000000000..a6a8d2c9042e
--- /dev/null
+++ b/src/ws/mock-ecc.key
@@ -0,0 +1,10 @@
+# openssl ecparam -out mock-ecc.key -name prime256v1 -genkey
+
+-----BEGIN EC PARAMETERS-----
+BggqhkjOPQMBBw==
+-----END EC PARAMETERS-----
+-----BEGIN EC PRIVATE KEY-----
+MHcCAQEEIIdevEpPq+LmSqzcYwKk0MgKLcTn7vUNPpvvoJl9v/yEoAoGCCqGSM49
+AwEHoUQDQgAE5BRvKPl0iCppAFY4luyrbS6wIRAV6CY3PkhNpWgcRk40q7Ev85LM
+7I2GwyMihC+GlrZkJ5cz0gzUrGawAsx/Iw==
+-----END EC PRIVATE KEY-----
diff --git a/src/ws/test-remotectlcertificate.c b/src/ws/test-remotectlcertificate.c
index 76d5118f674c..2cc2e1b5bc8a 100644
--- a/src/ws/test-remotectlcertificate.c
+++ b/src/ws/test-remotectlcertificate.c
@@ -164,8 +164,10 @@ test_combine_bad (TestCase *test,
 }
 
 const gchar *no_files[] = { NULL };
-const gchar *good_files[3] = { SRCDIR "/src/bridge/mock-server.crt",
-                               SRCDIR "/src/bridge/mock-server.key", NULL };
+const gchar *good_rsa_files[3] = { SRCDIR "/src/bridge/mock-server.crt",
+                                   SRCDIR "/src/bridge/mock-server.key", NULL };
+const gchar *good_ecc_files[3] = { SRCDIR "/src/ws/mock-ecc.crt",
+                                   SRCDIR "/src/ws/mock-ecc.key", NULL };
 const gchar *bad_files[2] = { "bad", NULL };
 const gchar *bad_files2[3] = { SRCDIR "/src/bridge/mock-server.crt", "bad2", NULL };
 const gchar *invalid_files1[3] = { SRCDIR "/src/ws/mock-config/cockpit/cockpit.conf",
@@ -174,9 +176,14 @@ const gchar *invalid_files2[3] = { SRCDIR "/src/bridge/mock-server.crt",
                                    SRCDIR "/src/bridge/mock-client.crt", NULL };
 const gchar *invalid_files3[2] = { SRCDIR "/src/bridge/mock-client.key", NULL };
 
-static const TestFixture fixture_good_file = {
+static const TestFixture fixture_good_rsa_file = {
   .expected_message = NULL,
-  .files = good_files
+  .files = good_rsa_files
+};
+
+static const TestFixture fixture_good_ecc_file = {
+  .expected_message = NULL,
+  .files = good_ecc_files
 };
 
 static const TestFixture fixture_bad_file = {
@@ -217,7 +224,9 @@ main (int argc,
 {
   cockpit_test_init (&argc, &argv);
 
-  g_test_add ("/remotectl-certificate/combine-good", TestCase, &fixture_good_file,
+  g_test_add ("/remotectl-certificate/combine-good-rsa", TestCase, &fixture_good_rsa_file,
+              setup, test_combine_good, teardown);
+  g_test_add ("/remotectl-certificate/combine-good-ecc", TestCase, &fixture_good_ecc_file,
               setup, test_combine_good, teardown);
   g_test_add ("/remotectl-certificate/combine-bad-file", TestCase, &fixture_bad_file,
               setup, test_combine_bad, teardown);
